<template>
    <div>
        <base-header class="header pb-8 pt-5 pt-lg-8 d-flex align-items-center">
            <!-- Mask -->
            <span class="mask bg-gradient-primary opacity-8"></span>

            <div class="row">
                <div class="col-xl-6 col-lg-6 mb-4 mb-xl-0">
                    <div class="card border-left-primary shadow h-100 py-2">
                        <div class="card-body">
                            <div class="row no-gutters align-items-center">
                                <div class="col mr-2">
                                    <div class="card-title text-uppercase text-muted mb-0">Topic Format
                                    </div>
                                    <div class="h2 font-weight-bold mb-0">[Company]/[App Name]/[Hotel
                                        Name]/[Buiding]/[Floor]/[ROOM]/POWER</div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-xl-6 col-lg-6 mb-4 mb-xl-0">
                    <div class="card border-left-primary shadow h-100 py-2">
                        <div class="card-body">
                            <div class="row no-gutters align-items-center">
                                <div class="col mr-2">
                                    <div class="card-title text-uppercase text-muted mb-0">Example Topic
                                    </div>
                                    <div class="h2 font-weight-bold mb-0">
                                        <span v-if="!company_id">COMPANY</span>
                                        <span v-else>{{company_name}}</span>/APPNAME/DEMOHOTEL/BUIDING1/FLOOR1/ROOM1/POWER/</div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </base-header>

        <div class="container-fluid mt--7">
                <div class="col-xl-12 order-xl-1">
                    <card shadow type="secondary">
                        <div slot="header" class="bg-white border-0">
                            <div class="row align-items-center">
                                <div class="col-8">
                                    <h3 class="mb-0">Setting Company</h3>
                                    <span class="text-danger" v-if="error">{{error}}</span>
                                </div>
                            </div>
                        </div>
                        <template>
                            <form @submit="checkData">
                                <h6 class="heading-small text-muted mb-4">Company</h6>
                                <div class="pl-lg-4">
                                    <div class="row">
                                        <div class="col-lg-4">
                                            <base-input alternative=""
                                                        label="Company"
                                                        placeholder="Company"
                                                        input-classes="form-control-alternative"
                                                        v-model="company_name"
                                                        :disabled="company_id ? true : false"
                                            />
                                        </div>
                                    </div>
                                </div>
                                <div class="col-lg-4">
                                    <button class="btn btn-lg btn-primary" v-if="!company_id" type="submit">Setting</button>
                                    <router-link class="btn btn-lg btn-primary" v-else :to="`/app`">Go setting app</router-link>
                                </div>
                            </form>
                        </template>
                    </card>
                </div>
            </div>
        </div>
</template>
<script>
  export default {
    name: 'manage-users',
    data() {
      return {
        company_id : '',
        company_name : '',
        message : '',
        error :''
      }
    },
    created() {
        this.getData()
    },
    methods: {
        getData(){
            this.error = ''
            this.$http.get('/manage/company/'+localStorage.user_id,
            {
          headers: {
            Authorization: 'Bearer ' + localStorage.token
            }
          })
            .then(response => { 
                this.company_id = response.data.company_id
                this.company_name = response.data.company_name
                this.message = response.data.message
          })
        },
        checkData(){
            if(this.company_name === ''){
                this.error = 'Please enter company'
            }else{
                this.$swal({
                    title: "Confirm create company?",
                    text : 'If created, can not edited!!',
                    icon: "warning",
                    buttons: ['cancel','confirm']
                })
                .then((confirm) => {
                    if (confirm) {
                    this.createCompany()
                }
          })
            }
        },
        createCompany(){
            this.$http.post('/manage/company/create',{
            headers: {
                Authorization: 'Bearer ' + localStorage.token
                }
            },{
                user_id : localStorage.user_id,
                company_name : this.company_name
            })
          .then(response => {
              if(response.data.message === 'success'){
                this.$swal({
                    title: "Created!",
                    icon: "success",
                    timer: 3000
                })
                this.getData()
              }else if(response.data.message === 'fail'){
                  this.error = 'Can not use this company !!'
              }
          })
          .catch(() => this.checkCreateCompany())
        },
        checkCreateCompany(){
            this.error = 'Create failed!!'
        }
    },
  };
</script>